SystemOrganization addCategory: #'TP2-TADP'!
SystemOrganization addCategory: #'TP2-TADP-Tests'!
SystemOrganization addCategory: #'TP2-TADP-ComposicionATrait'!
SystemOrganization addCategory: #'TP2-TADP-ComposicionATrait-Test'!
SystemOrganization addCategory: #'TP2-TADP-CompisiconATrait'!

TestCase subclass: #ComposicionATraitTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP-ComposicionATrait-Test'!

!ComposicionATraitTest methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/7/2013 01:44'!
setUp
	
	ComposicionATrait crearTraitConNombre:'TestUno'.
	
	"Creo una Clase para que en un asignarUsoDeTraitAUnaClaseTest el trait use esta clase"
	
	Object  subclass: #ClaseTest
 		instanceVariableNames: ''
 		classVariableNames: ''
 		poolDictionaries: ''
 		category: 'TP2-TADP-ComposicionATrait'.
	
	Object  subclass: #ClaseTestA
 		instanceVariableNames: ''
 		classVariableNames: ''
 		poolDictionaries: ''
 		category: 'TP2-TADP-ComposicionATrait'.
	
		
	(Smalltalk at:#ClaseTestA) subclass: #ClaseTestB
 		instanceVariableNames: ''
 		classVariableNames: ''
 		poolDictionaries: ''
 		category: 'TP2-TADP-ComposicionATrait'.
		
	(Smalltalk at:#ClaseTestA)  subclass: #ClaseTestC
 		instanceVariableNames: ''
 		classVariableNames: ''
 		poolDictionaries: ''
 		category: 'TP2-TADP-ComposicionATrait'.
		
	Object subclass: #ClaseParaEliminarReferenciasTest
 		instanceVariableNames: 'atributo'
 		classVariableNames: ''
 		poolDictionaries: ''
 		category: 'TP2-TADP-ComposicionATrait'.
		
	"Creo Metodos"
	(Smalltalk at:#ClaseTest)  compile:  'm0
	^0.'.
	(Smalltalk at:#ClaseTestA)  compile:  'm1
	^1.'.
	(Smalltalk at:#ClaseTestB)  compile:  'm2
	^2.'.
	(Smalltalk at:#ClaseTestC) compile:  'm3
	^3.'.
	(Smalltalk at:#ClaseParaEliminarReferenciasTest)  compile:  'm0
	^atributo haceAlgo.'.
		! !

!ComposicionATraitTest methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/7/2013 01:49'!
tearDown
	
	(Smalltalk at:#ClaseTest) removeFromSystem.
	(Smalltalk at:#ClaseTestA) removeFromSystem.
	(Smalltalk at:#ClaseTestB) removeFromSystem.
	(Smalltalk at:#ClaseTestC) removeFromSystem.
	(Smalltalk at:#ClaseParaEliminarReferenciasTest) removeFromSystem.
	
	(Smalltalk at:#TraitTestUno) removeFromSystem.
	
	! !

!ComposicionATraitTest methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/4/2013 16:05'!
testAsignarUsoDeTraitAUnaClase
	
	| testClass testTrait|
	
	testClass := Smalltalk at:#ClaseTest.
	testTrait := Smalltalk at:#TraitTestUno.
		
	"Es necesario asegurarme que el trait tenga comportamiento y NO este vacio porque sino cuando haga que una clase lo use va a romper"
	ComposicionATrait agregarMetodosDeLaClase: testClass AlTrait: testTrait ConClaseDeJerarquia: testClass.
	
	ComposicionATrait asignarUsoDelTrait: testTrait  aLaClaseConNombre: testClass name.
	
	self assert: testClass methodDictionary keys asString  equals: testTrait methodDictionary keys asString .
	! !

!ComposicionATraitTest methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/4/2013 16:04'!
testCopiarMetodosDeUnaClaseAUnTrait

	| testTrait unDiccionario |
	
	testTrait := Smalltalk at:#TraitTestUno.
	
	ComposicionATrait agregarMetodosDeLaClase: (Smalltalk at:#ClaseTest) AlTrait: testTrait ConClaseDeJerarquia: (Smalltalk at:#ClaseTest).
	
	unDiccionario :=  (Smalltalk at:#TraitTest) methodDictionary.
	
	self assert: (((Smalltalk at:#ClaseTest) methodDictionary) keys asString ) equals: ((testTrait methodDictionary) keys asString ).! !

!ComposicionATraitTest methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/4/2013 01:33'!
testCrearTrait

	| testTrait |
	
	testTrait := Smalltalk at:#TraitTestUno.
	
	self assert: #TraitTestUno equals: (testTrait name) asSymbol .! !

!ComposicionATraitTest methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/4/2013 16:03'!
testCrearTraitsConMetodosAPartirDeClaseConJerarquia

	ComposicionATrait crearTraitsDeClaseConJearquia: (Smalltalk at:#ClaseTestA).
	
	self assert:   (Smalltalk at:#TraitClaseTestA) methodDictionary keys asString  equals: '#(#m1)'.
	self assert:   (Smalltalk at:#TraitClaseTestB) methodDictionary keys asString  equals: '#(#m1 #m2)'.
	self assert:   (Smalltalk at:#TraitClaseTestC) methodDictionary keys asString  equals: '#(#m1 #m3)'.	
		
		
	"Lo logico seria que vaya en el TearDown pero a Pharo no le gusta."
	(Smalltalk at:#TraitClaseTestA) removeFromSystem.
	(Smalltalk at:#TraitClaseTestB) removeFromSystem.
	(Smalltalk at:#TraitClaseTestC) removeFromSystem.! !

!ComposicionATraitTest methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/7/2013 01:55'!
testEliminarAtributoYSustituirAtributoPorSelf
		ComposicionATrait eliminarAtributoConNombre: 'atributo' DeLaClase: (Smalltalk at:#ClaseParaEliminarReferenciasTest).
		self assert:	'm0
	^self haceAlgo.'
		equals:((Smalltalk at:#ClaseParaEliminarReferenciasTest)>>#m0) sourceCode asString.! !

Object subclass: #ComposicionATrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP-ComposicionATrait'!

!ComposicionATrait class methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/4/2013 00:09'!
agregarMetodosDeLaClase: unaClase AlTrait:unTrait ConClaseDeJerarquia:unaClaseConJerarquia

	| implementacionDeMetodos |
	
	implementacionDeMetodos := Set new.
	unaClase methodDictionary do:[:unMetodo| implementacionDeMetodos add: unMetodo getSource].
	
	implementacionDeMetodos do:[ :unaImplementacion | unTrait compile: unaImplementacion ].
	
	unaClase superclass name = unaClaseConJerarquia name
	ifTrue: [ unaClase superclass methodDictionary do:[ :unaImplementacion | unTrait compile: unaImplementacion ]].
	
	
	! !

!ComposicionATrait class methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/4/2013 16:21'!
asignarUsoDelTrait: unTrait aLaClaseConNombre: unNombreDeClase

	| unSymbol |
	
	unSymbol := unNombreDeClase asSymbol.
	
	Object subclass: unSymbol
	uses: unTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP-ComposicionATrait'.! !

!ComposicionATrait class methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/3/2013 22:20'!
componerEnTraitsLaClase:unaClase conNombreDeAtributoComposicion:unNombreDeAtributo conClaseConJerarquia:unaClaseConJerarquia
		
		self crearTraitsDeClaseConJearquia:unaClaseConJerarquia.
		self asignarUsoDelTrait: ('Trait',unaClaseConJerarquia name)  aLaClaseConNombre: unaClase name.
		self eliminarAtributoConNombre: unNombreDeAtributo DeLaClase:unaClase.! !

!ComposicionATrait class methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/4/2013 16:21'!
crearTraitConNombre:unNombreDeTrait
 
		| unSymbol |
		
		unSymbol :=('Trait', unNombreDeTrait) asSymbol.
		
		Trait named: unSymbol
       			uses: {}
       			category: 'TP2-TADP-CompisiconATrait'.! !

!ComposicionATrait class methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/3/2013 23:32'!
crearTraitsDeClaseConJearquia:unaClaseConJerarquia
	
		|traitsACrear|
		
		traitsACrear:=Set new.
		traitsACrear add: unaClaseConJerarquia.
		unaClaseConJerarquia allSubclasses do: [ :unaSubClase | traitsACrear add: unaSubClase].
		traitsACrear do:[ :unaClaseQueVaASerUnTrait | self crearTraitConNombre: unaClaseQueVaASerUnTrait name;
															 agregarMetodosDeLaClase: unaClaseQueVaASerUnTrait 
															 AlTrait: (Smalltalk at:(('Trait', unaClaseQueVaASerUnTrait name) asSymbol)) ConClaseDeJerarquia:unaClaseConJerarquia].
		
		! !

!ComposicionATrait class methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/4/2013 15:41'!
eliminarAtributoConNombre: unNombreDeAtributo DeLaClase:unaClase

		unaClase removeInstVarNamed:unNombreDeAtributo.
		
		unaClase methodDictionary do:[:unMetodo | unaClase compile: (unMetodo getSource copyReplaceTokens: unNombreDeAtributo with: 'self')].! !
